CREATE OR REPLACE
TRIGGER USR_BLOQ_QUANT_TRABNECECOMP BEFORE INSERT OR UPDATE OF QTPRCNVCOMPR ON TRABNECECOMP
FOR EACH ROW
DECLARE
   V_CDARVPROD VARCHAR2(20);
   V_NMPRODUTO VARCHAR2(50);
   V_GRUPOPER VARCHAR2(2);
   V_IDTIPLAN VARCHAR2(1);
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      IF SUBSTR(V_DSSERVMETHOD, 1, 14) = 'GravaNeceComp' THEN
         SELECT MAX(NVL(OPER.CDGRUPOPER,00))
           INTO V_GRUPOPER
           FROM OPERADOR O, OPERGRUPOP OPER
          WHERE OPER.CDOPERADOR  = O.CDOPERADOR
            AND OPER.CDGRUPOPER  = '06'
            AND O.CDOPERADOR = V_DSREMOTEOPER;
         IF V_GRUPOPER = '06' THEN
            SELECT NVL(MAX(CDARVPROD), '0'), NVL(MAX(NMPRODUTO), 'X')
              INTO V_CDARVPROD, V_NMPRODUTO
              FROM PRODUTO
               WHERE CDPRODUTO = NVL(:OLD.CDPRODNECCMP, :NEW.CDPRODNECCMP);
            IF NVL(:OLD.QTPRCNVCOMPR, 0) < NVL(:NEW.QTPRCNVCOMPR, 0) THEN
               RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! No  possivel alterar a quantidade atual '|| TO_CHAR(:OLD.QTPRCNVCOMPR) ||' para a quantidade posterior ' || TO_CHAR(:NEW.QTPRCNVCOMPR) ||' do item de solicitao '|| V_CDARVPROD || ' ' || V_NMPRODUTO, True);
            END IF;
         END IF;
      END IF;
   ELSE
      IF SUBSTR(V_DSSERVMETHOD, 1, 14) = 'GravaNeceComp' THEN
         SELECT MAX(NVL(OPER.CDGRUPOPER,00))
           INTO V_GRUPOPER
           FROM OPERADOR O, OPERGRUPOP OPER
          WHERE OPER.CDOPERADOR  = O.CDOPERADOR
            AND OPER.CDGRUPOPER  = '06'
            AND O.CDOPERADOR = V_DSREMOTEOPER;
         IF V_GRUPOPER = '06' THEN
            SELECT NVL(MAX(CDARVPROD), '0'), NVL(MAX(NMPRODUTO), 'X')
              INTO V_CDARVPROD, V_NMPRODUTO
              FROM PRODUTO
               WHERE CDPRODUTO = NVL(:OLD.CDPRODNECCMP, :NEW.CDPRODNECCMP);
            RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! No  possivel incluir o produto ' || V_CDARVPROD || ' ' || V_NMPRODUTO, True);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_QUANT_TRABNECECOMP','5.55XXX'); END;
/
